diff -udNr xdvik//jisx0208.h pxdvik//jisx0208.h
--- xdvik//jisx0208.h	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//jisx0208.h	2010-07-25 14:56:37.638074508 +0900
@@ -0,0 +1,3 @@
+
+/* JIS -> unicode */
+int jis2uni(int jis);
diff -udNr xdvik//main.c pxdvik//main.c
--- xdvik//main.c	2009-11-10 19:28:49.000000000 +0900
+++ pxdvik//main.c	2010-07-25 14:56:37.638074508 +0900
@@ -30,6 +30,14 @@
 #undef STRINGIFY
 #undef TOSTRING
 
+#ifdef	PTEX
+#include <ft2build.h>
+#include FT_FREETYPE_H
+#if	HAVE_FONTCONFIG
+#include <fontconfig/fontconfig.h>
+#endif	/* HAVE_FONTCONFIG */
+#endif	/* PTEX */
+
 static char XtRBool3[] = "Bool3";	/* resource for Bool3 */
 
 /* get these before setting `application_resources' */
@@ -750,7 +758,7 @@
 static void
 display_version_info(void)
 {
-    printf("%s version %s ", XDVIK_PROGNAME, XDVI_VERSION);
+    printf("%s version %s ", XDVIK_PROGNAME, XDVI_TERSE_VERSION_INFO);
 #ifdef MOTIF
     printf("(%s, runtime version %d.%d)\n",
 	   /* 	   XmVERSION, XmREVISION, XmUPDATE_LEVEL, */
@@ -759,7 +767,14 @@
 #else
     printf("%s\n", XDVI_GUI);
 #endif
-    printf("Libraries: %s, T1lib version %s\n", kpathsea_version_string, T1LIB_VERSIONSTRING);
+    printf("Libraries: %s, T1lib version %s", kpathsea_version_string, T1LIB_VERSIONSTRING);
+#ifdef PTEX
+    printf(", FreeType version %d.%d.%d", FREETYPE_MAJOR, FREETYPE_MINOR, FREETYPE_PATCH);
+#if HAVE_FONTCONFIG
+    printf(", Fontconfig version %d.%d.%d", FC_MAJOR, FC_MINOR, FC_REVISION);
+#endif /* HAVE_FONTCONFIG */
+#endif /* !PTEX */
+    printf("\n");
 }
 
 
diff -udNr xdvik//pk.c pxdvik//pk.c
--- xdvik//pk.c	2009-03-31 23:59:37.000000000 +0900
+++ pxdvik//pk.c	2010-07-25 14:56:37.638074508 +0900
@@ -201,6 +201,9 @@
 
     g->dvi_adv = fontp->dimconv * fpwidth;
 
+#ifdef PTEX
+    g->tdir = fontp->dir;
+#endif /* PTEX */
     if (globals.debug & DBG_PK) {
 	if (g->bitmap.w != 0)
 	    printf(", size=%dx%d, dvi_adv=%ld", g->bitmap.w, g->bitmap.h,
diff -udNr xdvik//psgs.c pxdvik//psgs.c
--- xdvik//psgs.c	2009-11-10 19:28:49.000000000 +0900
+++ pxdvik//psgs.c	2010-07-25 14:56:37.642073810 +0900
@@ -80,6 +80,16 @@
 extern const char psheader[];
 extern unsigned psheaderlen;
 
+/*
+** Modified 22/03/95.
+*/
+
+extern void psh_includeall();
+
+/*
+** End Modified.
+*/
+
 Boolean gs_postpone_prescan = False;
 
 /* global procedures (besides initGS) */
@@ -699,6 +709,19 @@
 	destroy_gs();
 	return False;
     }
+
+    /*
+    ** Modified 22/03/95.
+    */
+
+    GS_active = True; /*Just for now */
+    psh_includeall();
+    GS_active = False; /* Now, fixed! */
+
+    /*
+    ** End Modified.
+    */
+
     if (resource.postscript == 0)
 	toggle_gs(0);	/* if we got a 'v' already */
     else {
diff -udNr xdvik//ptexmap.c pxdvik//ptexmap.c
--- xdvik//ptexmap.c	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//ptexmap.c	2010-07-25 14:56:37.642073810 +0900
@@ -0,0 +1,229 @@
+#include "xdvi-config.h"
+#include "xdvi.h"
+#include "ptexmap.h"
+#include "util.h"
+#include "kpathsea/tex-file.h"
+#ifdef	PTEX
+#include "ft2.h"
+#include <ctype.h>
+
+#define NUM(a)	  ((int)(sizeof(a)/sizeof(*(a))))
+
+static int dictionaries_num = 0;
+static int dictionaries_max = 0;
+static struct dictionary {
+    char *key, *word;
+} *dictionaries = NULL;
+
+static struct dictionary *get_dictionary(char *key)
+{
+    int i;
+
+    if (key == NULL) return NULL;
+    for (i=0; i<dictionaries_num; i++) {
+	if (strcmp(key, dictionaries[i].key) == 0) {
+	    return &dictionaries[i];
+	}
+    }
+    return NULL;
+}
+
+void add_replace_dictionary(char *key, char *word)
+{
+    struct dictionary *d;
+
+    d = get_dictionary(key);
+    if (d == NULL) {
+	if (dictionaries_num == dictionaries_max) {
+	    if (dictionaries_max == 0) dictionaries_max = 16;
+	    else		       dictionaries_max *= 2;
+	    dictionaries = xrealloc(dictionaries,
+			     sizeof(dictionaries[0]) * dictionaries_max);
+	}
+	d = &dictionaries[dictionaries_num++];
+	d->key  = xstrdup(key);
+    } else {
+	XDVI_WARNING((stderr, "Duplication of replace entry '%s' was found. "
+		      "Overwrites '%s' with '%s'.\n", key, d->word, word));
+	free(d->word);
+    }
+
+    d->word = xstrdup(word);
+}
+
+static char *replace_string(char *key)
+{
+    struct dictionary *d = get_dictionary(key);
+    if (d == NULL) return key;
+    return d->word;
+}
+
+
+static int ptexmaps_num = 0;
+static int ptexmaps_max = 0;
+static struct ptexmap *ptexmaps = NULL;
+
+struct ptexmap *getkanjifont(const char *jfm_name)
+{
+    int i;
+
+    for (i=0; i<ptexmaps_num; i++) {
+	if (strcmp(jfm_name, ptexmaps[i].jfm_name) == 0) {
+	    return &ptexmaps[i];
+	}
+    }
+    return NULL;
+}
+
+static struct ptexmap *add_fontmap2(char *jfm, char *font, int encoding,
+				    char *map_filename)
+{
+    struct ptexmap *map;
+
+    map = getkanjifont(jfm);
+    if (map == NULL) {
+	if (ptexmaps_num == ptexmaps_max) {
+	    if (ptexmaps_max == 0) ptexmaps_max = 8;
+	    else		   ptexmaps_max *= 2;
+	    ptexmaps = xrealloc(ptexmaps, sizeof(ptexmaps[0]) * ptexmaps_max);
+	}
+	map = &ptexmaps[ptexmaps_num++];
+	map->jfm_name = xstrdup(jfm);
+    } else {
+	XDVI_WARNING((stderr, "A ptexmap entry for '%s' in \"%s\" duplicates "
+		      "a former entry in \"%s\". Overwrites.\n",
+		      jfm, map_filename, map->map_filename));
+	free(map->font_filename);
+    }
+
+    map->face_index = 0;
+    map->ft2_index = -1;
+    if (sscanf(font, ":%d:", &map->face_index) == 1) {
+	font = strchr(font+1, ':') + 1;
+    }
+    map->font_filename  = xstrdup(replace_string(font));
+    map->encoding = encoding;
+    map->extend = 1.0;
+    map->slant  = 0.0;
+    map->variant = 0;
+    map->map_filename = map_filename;
+    return map;
+}
+
+int str2encoding(char *enc_name) {
+    int i;
+    static struct {
+	char *enc_name;
+	int encoding;
+    } encodes[] = {
+	{ "JIS-H",      ENC_JIS_H },
+	{ "JIS-V",      ENC_JIS_V },
+	{ "Unicode-H",  ENC_UNICODE_H },
+	{ "Unicode-V",  ENC_UNICODE_V },
+	{ "Identity-H", ENC_IDENTITY },
+	{ "Identity-V", ENC_IDENTITY },
+	/* caution: Identity-H = Identity-V */
+    };
+
+    if (enc_name == NULL) return ENC_UNKNOWN;
+    for (i=0; i<NUM(encodes); i++) {
+	if (strcmp(enc_name, encodes[i].enc_name) == 0) {
+	    return encodes[i].encoding;
+	}
+    }
+    return ENC_UNKNOWN;
+}
+
+static int add_fontmap(char *line, char *map_filename)
+{
+    struct ptexmap *map;
+    char *s, *jfm, *font, *enc;
+    int encoding = 0;
+    float *ptr = NULL;
+
+    jfm  = strtok(line, " \t");
+    enc  = replace_string(strtok(NULL, " \t"));
+    font = strtok(NULL, " \t,!");
+    encoding = str2encoding(enc);
+
+    if (jfm == NULL) return true; /* empty line */
+
+    if (font == NULL) {
+	XDVI_WARNING((stderr, "A font name for \"%s\" is empty.\n",
+		      jfm));
+	return true;
+    }
+
+    if (encoding == ENC_UNKNOWN) {
+	XDVI_WARNING((stderr, "Unknown encode \"%s\" for \"%s\".\n",
+		      enc, jfm));
+	return true;
+    }
+
+    if (globals.debug & DBG_PK) {
+	fprintf(stderr, "JFM name is \"%s\".\n", jfm);
+	fprintf(stderr, "Font filename is \"%s\".\n", font);
+	fprintf(stderr, "Font is %s encode (#%d).\n", enc, encoding);
+    }
+
+    map = add_fontmap2(jfm, font, encoding, map_filename);
+
+    while ((s=strtok(NULL, " \t,\r\n")) != NULL) {
+	if      (strcmp(s, "-e") == 0) ptr = &map->extend;
+	else if (strcmp(s, "-s") == 0) ptr = &map->slant;
+	else if (strcmp(s, "Bold") == 0)   map->variant |= VAR_BOLD;
+	else if (strcmp(s, "Italic") == 0) map->variant |= VAR_ITALIC;
+	else if (strcmp(s, "BoldItalic") == 0) {
+	    map->variant |= VAR_BOLD | VAR_ITALIC;
+	} else if ((isdigit(*s) || *s == '.' || *s == '-') && ptr != NULL) {
+	    *ptr = atof(s);
+	} else return false;
+    }
+    return true;
+}
+
+
+char *get_ptexmap_name(char *filename)
+{
+    char *s = NULL;
+    FILE *fp;
+
+    if ((fp=fopen(filename, "r")) != NULL) {
+	fclose(fp);
+	s = xstrdup(filename);
+    }
+    if (s == NULL) s = kpse_find_file(filename, kpse_fontmap_format, true);
+    return s;
+}
+
+
+void read_ptexmap_file(char *filename)
+{
+    FILE *fp;
+    char *s;
+    char line[BUFSIZ], line_orig[BUFSIZ];
+
+    filename = get_ptexmap_name(filename);
+    /* 'filename' will stored in ptexmap structure,
+       so we can't free(filename) in this function. */
+    if ((fp = fopen(filename, "r")) == NULL) {
+	XDVI_WARNING((stderr, "Warning: Can't open \"%s\"\n", filename));
+	return;
+    }
+    if (globals.debug & DBG_FILES) {
+	TRACE_FILES((stderr, "read_ptexmap_file for |%s|", filename));
+    }
+
+    while (fgets(line, BUFSIZ, fp) != NULL) {
+	if ((s=strchr(line,'\n')) != NULL) *s = '\0'; /* break \n */
+	strcpy(line_orig, line);
+	if ((s=strchr(line,'%'))  != NULL) *s = '\0'; /* break comment */
+	if ((s=strchr(line,'#'))  != NULL) *s = '\0'; /* break comment */
+
+	if (!add_fontmap(line, filename)) {
+	    XDVI_WARNING((stderr, "'%s', Unknown option.\n", line_orig));
+	}
+    }
+    fclose(fp);
+}
+#endif	/* PTEX */
diff -udNr xdvik//ptexmap.h pxdvik//ptexmap.h
--- xdvik//ptexmap.h	1970-01-01 09:00:00.000000000 +0900
+++ pxdvik//ptexmap.h	2010-07-25 14:56:37.642073810 +0900
@@ -0,0 +1,22 @@
+
+#ifdef PTEX
+struct ptexmap {
+    char *jfm_name;
+    char *font_filename;
+    int ft2_index;
+    int face_index;
+    enum { ENC_UNKNOWN, ENC_JIS_H, ENC_JIS_V, ENC_UNICODE_H, ENC_UNICODE_V,
+	   ENC_IDENTITY } encoding;
+    enum { VAR_BOLD = 0x01, VAR_ITALIC = 0x02 } variant;
+    float extend, slant;
+    char *sfd_name;
+    char *csi;
+    char *map_filename; /* only for warning message */
+};
+
+void read_ptexmap_file(char *filename);
+struct ptexmap *getkanjifont(const char *jfm_name);
+#define iskanjifont(jfm_name) (getkanjifont(jfm_name) != NULL)
+
+void add_replace_dictionary(char *key, char *word);
+#endif	/* PTEX */
